import { Injectable } from '@nestjs/common';
import { DistributeTransactionDto } from './dto/distribute-transaction.dto';
import { OrderTransactionDto } from './dto/order-transaction.dto';
import { UpdateTransactionDto } from './dto/update-transaction.dto';
import { InjectRepository } from '@nestjs/typeorm';
import { Transactions } from './entities/transactions.entity';
import { Connection, Repository } from 'typeorm';
import { COA } from './entities/coa.entity';
import { TransactionType } from './entities/transaction-type.entity';
import { TransactionJournal } from './entities/transaction-journal.entity';
import { CoaService } from './coa.service';
import { statusTransaction } from '../helper/enum-list';
import { ProductService } from '../product/product.service';

@Injectable()
export class TransactionService {
  constructor(
    @InjectRepository(Transactions)
    private transactionRepository: Repository<Transactions>,
    @InjectRepository(TransactionType)
    private transactionTypeRepository: Repository<TransactionType>,
    @InjectRepository(TransactionJournal)
    private transactionJournalRepository: Repository<TransactionJournal>,
    @InjectRepository(COA)
    private coaRepository: Repository<COA>,
    private coaService: CoaService,
    private connection: Connection,
  ) {}

  async distributeDeposit(distributeTransactionDto: DistributeTransactionDto) {
    // GET COA
    const coaSender = await this.coaService.findByUser('id_user');
    const coaReciever = await this.coaService.findByUser('id_user');

    // GET TYPE TRANSAKSI

    await this.connection.transaction(async (manager) => {
      //INSERT TRANSACTION
      const transactionSaved = await manager.insert(Transactions, {
        amount: distributeTransactionDto.amount,
        user: 'id_user',
        userDestination: distributeTransactionDto.destination,
        status: statusTransaction.SUCCESS,
      });

      //INSERT TRANSACTION JOURNAL FOR SENDER
      const journalSender = await manager.insert(TransactionJournal, {
        amount: distributeTransactionDto.amount,
        transaction: transactionSaved.identifiers[0],
        coa: coaSender,
      });

      //INSERT TRANSACTION JOURNAL FOR RECEIVER
      const journalReceiver = await manager.insert(TransactionJournal, {
        amount: distributeTransactionDto.amount,
        transaction: transactionSaved.identifiers[0],
        coa: coaReciever,
      });

      //UPDATE AMOUNT COA SENDER
      coaSender.amount = coaSender.amount - distributeTransactionDto.amount;
      await manager.save(coaSender);

      coaReciever.amount = coaReciever.amount + distributeTransactionDto.amount;
      await manager.save(coaReciever);
    });

    return true;
  }

  async orderTransaction(orderTransactionDto: OrderTransactionDto) {
    // const product = await this.productService.findOne(
    //   orderTransactionDto.productCode,
    // );

    return true;
  }

  findOne(id: number) {
    return `This action returns a #${id} transaction`;
  }

  update(id: number, updateTransactionDto: UpdateTransactionDto) {
    return `This action updates a #${id} transaction`;
  }

  remove(id: number) {
    return `This action removes a #${id} transaction`;
  }
}
